$LOAD_PATH.unshift File.expand_path('../../lib/picatrix/generated', __FILE__)

require "picatrix/version"
require "protobuf"
require "parslet"
require "graphviz"
require "active_support"
require "active_support/core_ext/string"
require "thor"

require "picatrix/pacman"
require "picatrix/digraph_parser"
require "picatrix/transform_to_hash"
require "picatrix/buffy"
require "picatrix/link_relation_index"
require "picatrix/routes"
require "picatrix/protoc"
require "picatrix/cruddy"
require "picatrix/prototyper"
require "picatrix/jenny"

module Picatrix
  class CLI < Thor
    desc "g <dot file name> <optional: app name>",
      "generates Sinatra app, uses dot file name for app name if none given"
    option :force, :type => :boolean

    def g(dot_file_name, app_name = nil)
      app_name = File.basename(dot_file_name, ".dot") if app_name.nil?

      puts "using: #{dot_file_name}"
      puts "output: #{app_name}"

      Jenny.new(
        Pacman.new(
          dot_file_name
        ),
        options,
        app_name
      ).just_do_it
    end

    desc "prep <dot file name> <app name>", "outputs an image and protobuf templates"
    def prep(dot_file_name, app_name = nil)
      app_name = File.basename(dot_file_name, ".dot") if app_name.nil?

      GraphViz.parse(dot_file_name, :path => "/usr/local/bin").
        output(:png => "#{dot_file_name}.png")
      puts "output to #{dot_file_name}.png"

      Buffy.new(
        Pacman.new(
          dot_file_name
        ),
        options,
        app_name
      ).slay

      puts "output to generated/"
      puts "You will need to edit your #{app_name}.proto file to match your schema." +
        " Then you can run `picapica g <app_name>` to generate your application."
    end
  end
end
