require 'sinatra'
require 'sinatra/json'
require 'protobuf'
require 'require_all'

$:.unshift(File.join(File.dirname(__FILE__)))
$:.unshift(File.join(File.dirname(__FILE__), 'support'))
$:.unshift(File.join(File.dirname(__FILE__), 'resources'))

require("./generated/<%= @app_name %>/support/picatrix.mason.pb")
require("./generated/<%= @app_name %>/support/mason")
require("./generated/<%= @app_name %>/support/<%= @app_name %>.pb")
require_all("generated/<%= @app_name %>/resources/*.rb")

class <%= @app_name.camelize %> < Sinatra::Base
  include Picatrix::Mason

  set :public_folder => "public", :static => true

  get '/rels' do
    json(<%= @rels %>)
  end

  get '/' do
    status, headers, body = call env.merge("PATH_INFO" => "/<%= @routes.root_path %>")
    [status, headers, body]
  end

  def json(hash = {})
    # anything set here will be sent in all responses
    super(<%= @namespaces %>.merge!(hash))
  end

<% @routes.unique_routes.each do |route| %>
<%= route[:method] %> "/<%= route[:path] %>" do
<% if route[:response_resource][:collection] %>
     response_body = {"<%= route[:response_resource][:name].to_s.underscore %>" => <%= route[:response_resource][:name] %>Resource.as_hashes}
<% else %>
     response_body = <%= route[:response_resource][:name].to_s.pluralize.constantize %>Resource.<%= send_method_for(route[:method]).to_s %>(params[:item_id]).to_hash.except(:controls)
<% end %>
     controls = {}
<% if @routes.controls[route[:target]][route[:method]] %>
<% @routes.controls[route[:target]][route[:method]].each do |control| %>
     controls.merge!(send("<%= control %>".to_sym, <%= route[:response_resource][:name] %>).call("<%= route[:target] %>".pluralize, params))
<% end %>
<% end %>
     json({
       :@controls => controls
     }.merge!(response_body))
   end
<% end %>
end
