# you can remove this if you don't use faker
# for your fixture data
require 'faker'

# the resource is the thing actually persisted
# technically, this is just an interface to it
# so long as your persistance layer is able to implement
# the methods in this fixture, the app will generate
class <%= @resource_name %>Resource
  # method used to return single item from a collection
  # creates an instance on the fly
  # both the find and collection methods use this
  def self.create(item_id)
    <%= @resource_name.singularize %>.new(
      {
        # any "bare" Proto type will be given an associated Faker
        <% @fields.keys.each do |field_key| %>
        :<%= field_key %> => <%= @fields[field_key] %>,
        <% end %>
      }
    )
  end
  def self.find(params)
    self.create(params)
  end
  def self.all
    collection = []
    rand(10).times {
      collection << self.find(rand(1000))
    }
    <%= @resource_name %>.new(collection: collection)
  end
  def self.as_hashes
    self.all.collection.map(&:to_hash)
  end
  # this makes no sense on this class
  def self.minimal_controls_for(item_id)
    host = "http://localhost:9292"
    {
      self: ::Picatrix::Mason::Self.new(href: "#{host}/<%= @resource_name.underscore %>/#{item_id}"),
      up: ::Picatrix::Mason::Up.new(href: "#{host}/<%= @resource_name.underscore %>")
    }
  end
end
