module Picatrix
  class TransformToHash < Parslet::Transform
    rule(:node => subtree(:node)) do
      {
        node: {
          String(node[:name]) => {
            label: String(node[:label]).delete('"'),
          }
        }
      }
    end
    rule(:edge => subtree(:edge)) do
      method =
        if edge[:post].present?
          if String(edge[:style]).include?("bold")
            :post
          else
            :patch
          end
        elsif String(edge[:style]).include?("red")
          :delete
        else
          :get
        end
      {
        edge: {
          String(edge[:outbound]) => {
            target: String(edge[:inbound]).delete(" {} "),
            link_relation: String(edge[:link_relation]).delete('"'),
            method: method
          }
        }
      }
    end
  end
end
